%% Plot
%  Percentage Change in MSE Relative to Plug-in Predictor

clear all
close all
clc

addpath('../../Tools')

temp_path = '../../temp/'; 
result_path = '../../results/'; 
subfolder = 'Application/';
version_tag = '';

%% Sample prepare

yr0 = 2002;
yr1 = 2014;
n_sim = 1;

n_param = 3; % order: rho sigma2 ww2_lambda

v_bw = .1:.1:1.9;
n_bw = length(v_bw);

v_K = 1:5;
n_K = length(v_K);

n_est = 4;

%% Plot prepare

v_estplot = [n_est-3 n_est-2 n_est n_est-1];
n_estplot = length(v_estplot);

SFont = 16;

for T = 4:2:10
    
    T_smpl = (yr1-yr0)*4+4-1-T;
    fcst_plot = nan(T_smpl,n_estplot-1);

    %% Forecast
    
    for t_smpl = T+(1:T_smpl)
        
        yr_smpl = floor((t_smpl+1-2)/4)+yr0;
        qtr_smpl = mod((t_smpl+1-2),4)+1;
        
        label = ['T' num2str(T) '_tau' num2str(yr_smpl) 'q' num2str(qtr_smpl) '_']
        load([temp_path subfolder label 'results.mat'])
        N = size(Y,2);
        
        fcst = all_lambda(v_estplot,:)...
            +kron(reshape(all_param(1,v_estplot,:),n_estplot,n_sim),ones(1,N)).*Y(end-1,:);
        errs = Y(end,:)-fcst;
        
        aux = mean(errs.^2,2);
        fcst_plot(t_smpl-T,:) = (aux(1:end-1)-aux(end))/aux(end); % normalized by the plug-in predictor

    end
    
    %% Plot
    
    v_tau = (yr0+(T-1+(1:T_smpl))/4)';       
    app_fmse_plot;
    close all
    
end
