%% Post Mean (QMLE, Kernel LOO, bhat)

all_param(1:2,i_est) = all_param(1:2,i_est_ref); % Initialize common parameters by QMLE

%% Pseudo out-of-sample fcst and select bw

X1 = XX(end,:);
Y1 = YY(end,:);
W1 = WW(end,:);

aX = XX;
aY = YY;
aW = WW;
XX = XX(1:end-1,:);
YY = YY(1:end-1,:);
WW = WW(1:end-1,:);

param = all_params_pseudo;
rho0 = param(1);
sigma2_0 = param(2);

construct_lambda0;
s_lambda0 = std(lambda0');
s_Y0 = std(Y0);

lambda_aux = nan(n_lambda,N,n_bw);

for i_bw = 1:n_bw
    bw = v_bw(i_bw)*bw0;
    
    q_zy_aux = normpdf(Y0,Y0',s_Y0*bw);
    for i_lambda = 1:n_lambda
        q_zy_aux = q_zy_aux.*normpdf(lambda0(i_lambda,:),...
            lambda0(i_lambda,:)',s_lambda0(i_lambda)*bw);
    end
    q_zy = mean(q_zy_aux-diag(diag(q_zy_aux))); % take ratio, so the factor N/(N-1) will cancel out
    
    dq_zy = nan(n_lambda,N);
    for i_lambda = 1:n_lambda
        dq_zy(i_lambda,:) = -mean(q_zy_aux...
            .*(lambda0(i_lambda,:)-lambda0(i_lambda,:)')/(s_lambda0(i_lambda)*bw)^2);
    end
    
    lambda_aux(:,:,i_bw) = lambda0+((WW'*WW)\dq_zy)./q_zy*sigma2_0;
    
end

all_z = zeros(n_bw,N);
for i_bw = 1:n_bw
    all_z(i_bw,:) = W1*lambda_aux(:,:,i_bw);
end
errs = Y1-rho0*X1-all_z;

[~,i_bw_min] = min(mean(errs.^2,2));

all_bhat = v_bw(i_bw_min);

XX = aX;
YY = aY;
WW = aW;

%% Real fcst based on selected bw

rho0 = all_param(1,i_est);
sigma2_0 = all_param(2,i_est);

construct_lambda0;
s_lambda0 = std(lambda0');
s_Y0 = std(Y0);

bw = all_bhat*bw0;

q_zy_aux = normpdf(Y0,Y0',s_Y0*bw);
for i_lambda = 1:n_lambda
	q_zy_aux = q_zy_aux.*normpdf(lambda0(i_lambda,:),...
		lambda0(i_lambda,:)',s_lambda0(i_lambda)*bw);
end
q_zy = mean(q_zy_aux-diag(diag(q_zy_aux))); % take ratio, so the factor N/(N-1) will cancel out

dq_zy = nan(n_lambda,N);
for i_lambda = 1:n_lambda
	dq_zy(i_lambda,:) = -mean(q_zy_aux...
		.*(lambda0(i_lambda,:)-lambda0(i_lambda,:)')/(s_lambda0(i_lambda)*bw)^2);
end

all_lambda(:,:,i_est) = lambda0+((WW'*WW)\dq_zy)./q_zy*sigma2_0;