%% Post Mean (QMLE, Mixture, Khat)

all_param(1:2,i_est) = all_param(1:2,i_est_ref); % Initialize common parameters by QMLE
all_Khat = nan(n_K+2,1);

%% Pseudo out-of-sample fcst and select K

X1 = XX(end,:);
Y1 = YY(end,:);
W1 = WW(end,:);

aX = XX;
aY = YY;
aW = WW;
XX = XX(1:end-1,:);
YY = YY(1:end-1,:);
WW = WW(1:end-1,:);

param = all_params_pseudo;
rho0 = param(1);
sigma2_0 = param(2);

construct_lambda0;

lambda_aux = nan(n_lambda,N,n_K);

for i_K = 1:n_K
    K = v_K(i_K);
    
    [~,model] = mixGaussEm([lambda0;Y0],K,init_grp);
    KK = length(model.w);
    
    q_zy = 0;
    dq_zy = 0;
    for k = 1:KK
        q_zy = q_zy+model.w(k)*mvnpdf([lambda0' Y0'],model.mu(:,k)',model.Sigma(:,:,k))';
        inv_Sigma = inv(model.Sigma(:,:,k));
        dq_zy = dq_zy-model.w(k)*mvnpdf([lambda0' Y0'],model.mu(:,k)',model.Sigma(:,:,k))'...
            .*(inv_Sigma(1:end-1,:)*([lambda0; Y0]-model.mu(:,k)));
    end
    lambda_aux(:,:,i_K) = lambda0+((WW'*WW)\dq_zy)./q_zy*sigma2_0;

    all_Khat(i_K) = KK;
end

all_z = zeros(n_K,N);
for i_K = 1:n_K
    all_z(i_K,:) = W1*lambda_aux(:,:,i_K);
end
errs = Y1-rho0*X1-all_z;

[~,i_K_min] = min(mean(errs.^2,2));

all_Khat(n_K+1) = all_Khat(i_K_min);

XX = aX;
YY = aY;
WW = aW;

%% Real fcst based on selected K

rho0 = all_param(1,i_est);
sigma2_0 = all_param(2,i_est);

construct_lambda0;

K = all_Khat(n_K+1);
[~,model] = mixGaussEm([lambda0;Y0],K,init_grp);
KK = length(model.w);

q_zy = 0;
dq_zy = 0;
for k = 1:KK
    q_zy = q_zy+model.w(k)*mvnpdf([lambda0' Y0'],model.mu(:,k)',model.Sigma(:,:,k))';
    inv_Sigma = inv(model.Sigma(:,:,k));
    dq_zy = dq_zy-model.w(k)*mvnpdf([lambda0' Y0'],model.mu(:,k)',model.Sigma(:,:,k))'...
        .*(inv_Sigma(1:end-1,:)*([lambda0; Y0]-model.mu(:,k)));
end
all_lambda(:,:,i_est) = lambda0+((WW'*WW)\dq_zy)./q_zy*sigma2_0;
all_Khat(n_K+2) = KK;

