function f = n_log_ml_CRE_multilambda(param)
% f = -2 * log marginal likelihood

% suppress warning messages - not affect the optimization procedure
warning('off','MATLAB:nearlySingularMatrix');
warning('off','MATLAB:singularMatrix');

global N WW XX YY Y0
n_param = length(param)+1;
n_lambda = n_param-2;
T = size(WW,1);
sigma2 = param(1);
ww2_lambda = param(end-n_lambda+1:end);

H = [ones(1,N); Y0];
MH = eye(N)-(H'/(H*H'))*H;

MW = eye(T)-(WW/(WW'*WW))*WW';
PW = (WW'*WW)\WW';
V_lambdahat = diag(ww2_lambda)+sigma2*eye(n_lambda)/(WW'*WW);

rho = (trace(MW*YY*XX'/sigma2)+trace(V_lambdahat\PW*YY*MH*XX'*PW'))...
    /(trace(MW*XX*XX'/sigma2)+trace(V_lambdahat\PW*XX*MH*XX'*PW'));

ZZ = YY-rho*XX;

% accommodate cases with ww_lambda2 = 0
f = trace(MW*ZZ*ZZ'/sigma2)+trace(V_lambdahat\PW*ZZ*MH*ZZ'*PW')...
    +N*log(det(V_lambdahat))+N*(T-n_lambda)*log(sigma2);

% enable warning messages back
warning('on','all')

end