% Estimate common parameters for pseudo-out-of-sample forecasts that help with the selection of bhat or Khat 

aX = XX;
aY = YY;
aW = WW;
XX = XX(1:end-1,:);
YY = YY(1:end-1,:);
WW = WW(1:end-1,:);

est_within;
construct_lambda0;

aux_u = YY-all_param(1,i_est_ref)*XX-WW*lambda0;
aux_Y0 = [ones(1,N); Y0];
aux_coef = (aux_Y0*aux_Y0')\aux_Y0*lambda0';
aux_res = lambda0'-aux_Y0'*aux_coef;
init_pseudo = [var(aux_u(:)); var(aux_res)'];

param = fmincon(@n_log_ml_CRE_multilambda,init_pseudo,[],[],[],[],lb,ub,[],options);
sigma2_0 = param(1);
ww2_lambda0 = param(end-n_lambda+1:end);

H = [ones(1,N); Y0];
MH = eye(N)-(H'/(H*H'))*H;

MW = eye(size(WW,1))-(WW/(WW'*WW))*WW';
PW = (WW'*WW)\WW';
V_lambdahat = diag(ww2_lambda0)+sigma2_0*eye(n_lambda)/(WW'*WW);

rho = (trace(MW*YY*XX'/sigma2_0)+trace(V_lambdahat\PW*YY*MH*XX'*PW'))...
    /(trace(MW*XX*XX'/sigma2_0)+trace(V_lambdahat\PW*XX*MH*XX'*PW'));

XX = aX;
YY = aY;
WW = aW;
all_params_pseudo = [rho0 sigma2_0]';
