%% Plot:
%  Joint distributions of lambda and y0

mkdir ../../results/Experiment2
result_path = '../../results/';
subfolder = 'Experiment2/';

N = 1000; 

sigma2 = 1;
rho = 0.8;
mu_lambda = 1;
w2_lambda = 1;
v_ddelta = [.05 .1 .3];
l_ddelta = {'05','10','30'};
n_ddelta = length(v_ddelta);

ww2_lambda = 1/((1-rho^2)/sigma2/(1-rho)^2+1/w2_lambda);
mmu = ww2_lambda*[mu_lambda/w2_lambda (1-rho^2)/sigma2/(1-rho)]';
mu_y0 = mu_lambda/(1-rho);
w2_y0 = sigma2/(1-rho^2)+w2_lambda/(1-rho)^2;

n_y = 100;
v_q = 1/n_y/2:1/n_y:(1-1/n_y/2);
v_y = norminv(v_q,mu_y0,sqrt(w2_y0));

n_x = 100;

%% (lambda,y0)

F = figure;
for i_ddelta = 1:n_ddelta
    
    ddelta = v_ddelta(i_ddelta);
    x_upper = mmu(1)+ddelta+(mmu(2)+ddelta)*mu_y0+3*sqrt((mmu(2)+ddelta)^2*w2_y0+ww2_lambda);
    x_lower = mmu(1)-ddelta+(mmu(2)-ddelta)*mu_y0-3*sqrt((mmu(2)-ddelta)^2*w2_y0+ww2_lambda);
    v_x = linspace(x_lower,x_upper,n_y);
    
    [m_x,m_y] = meshgrid(v_x,v_y);
    m_f = (normpdf(m_x,mmu(1)+ddelta+(mmu(2)+ddelta)*m_y,sqrt(ww2_lambda))...
            +normpdf(m_x,mmu(1)-ddelta+(mmu(2)-ddelta)*m_y,sqrt(ww2_lambda)))/2.*normpdf(m_y,mu_y0,sqrt(w2_y0));

    contour(m_x,m_y,m_f,20)
    xlim([v_x(1) v_x(end)])
    ylim([v_y(1) v_y(end)])
    set(gca,'FontSize',16,'FontWeight','bold')
    
    set(F,'Units','Inches','position',[0 0 3 3]);
    set(F,'PaperOrientation','Portrait');
    set(F,'PaperPositionMode','Auto');
    set(F,'Clipping','off')
    print(F,[result_path subfolder 'dgp_delta' l_ddelta{i_ddelta}],'-dpng');
end