function [m_lambda,v_lambda] = post_mean_lambda_misspeclik(rho,mix,mmu,ww2_lambda,ddelta) 

global N T XX YY Y0

mu_u = mix(1:2);
gamma2_u = mix(3:4);
p_u = mix(5);

ZZ = YY-rho*XX;
mu_pos = mmu(1)+ddelta+(mmu(2)+ddelta)*Y0;
mu_neg = mmu(1)-ddelta+(mmu(2)-ddelta)*Y0;

B_draw = 500;
N_draw = 1500;
mlambda_draw = nan(B_draw+N_draw,N);
vlambda_draw = nan(B_draw+N_draw,N);
lambda0 = mean(ZZ);

for i_draw = 1:B_draw+N_draw
    
    %% step 1 draw a
    
    a0 = p_u*normpdf(ZZ-lambda0-mu_u(1),0,sqrt(gamma2_u(1))) > (1-p_u)*normpdf(ZZ-lambda0-mu_u(2),0,sqrt(gamma2_u(2)));
    
    %% step 2 draw lambda
    
    ZZ1 = ZZ-mu_u(1)*a0-mu_u(2)*(1-a0);
    v_ZZ1 = gamma2_u(1)*(a0==1)+gamma2_u(2)*(a0==0);
    pz = [prod(normpdf(ZZ1,mu_pos,sqrt(ww2_lambda+v_ZZ1)));...
        prod(normpdf(ZZ1,mu_neg,sqrt(ww2_lambda+v_ZZ1)))];
    p_pos = pz(1,:)./sum(pz);
    p1 = [p_pos; 1-p_pos];
    v1 = 1./(1/ww2_lambda+sum(1./v_ZZ1));
    m1 = [(mu_pos/ww2_lambda+sum(ZZ1./v_ZZ1)).*v1;...
        (mu_neg/ww2_lambda+sum(ZZ1./v_ZZ1)).*v1];

    mlambda_draw(i_draw,:) = sum(p1.*m1);
    vlambda_draw(i_draw,:) = sum(p1.*v1)+sum(p1.*(m1.^2))-mlambda_draw(i_draw,:).^2;
    
    v = rand(1,N)<p_pos;
    lambda0 = randn(1,N).*sqrt(v1)+m1(1,:).*(v==1)+m1(2,:).*(v==0);
    
end

m_lambda = mean(mlambda_draw(B_draw+(1:N_draw),:));
v_lambda = mean(vlambda_draw(B_draw+(1:N_draw),:)+mlambda_draw(B_draw+(1:N_draw),:).^2)-m_lambda.^2;

end