%% Plot:
%  Distributions of U_{it}

mkdir ../../results/Experiment3
result_path = '../../results/';
subfolder = 'Experiment3/';

v_mix = [0 0 4 1/4 1/5; 2 -1/4 1/2 1/2 1/9];
n_mix = size(v_mix,1);
x = (-4:.01:4)';
n_x = length(x);
f = nan(n_x,3);

f(:,1) = normpdf(x,0,1);
for i_mix = 1:n_mix
    mu = v_mix(i_mix,1:2);
    gamma2 = v_mix(i_mix,3:4);
    p = v_mix(i_mix,5);
    f(:,i_mix+1) = p*normpdf(x,mu(1),sqrt(gamma2(1)))+(1-p)*normpdf(x,mu(2),sqrt(gamma2(2)));
end

F = figure;
hold on
plot(x,f(:,1),'color',[.2 .2 .2],'linestyle',':','linewidth',2)
plot(x,f(:,2),'color',[0 .5 .5],'linestyle','-','linewidth',2)
plot(x,f(:,3),'color',[1 .5 0],'linestyle','--','linewidth',2)
hold off
xlim([-4 4])
set(gca,'FontSize',16,'FontWeight','bold')
box on

set(F,'Units','Inches','position',[0 0 3 3]);
set(F,'PaperOrientation','Portrait');
set(F,'PaperPositionMode','Auto');
set(F,'Clipping','off')
print(F,[result_path subfolder 'mixture'],'-dpng');
