% Plot:
% Percentage Change in MSE Relative to Plug-in Predictor
% Sorted series summarized over all samples

if isempty(version_tag) % basic model
    yylim = [-.2 .7];    
elseif strcmp(version_tag,'_hetero1') % w/ UR
    yylim = [-.8 .5];
else % w/ UR, FFR, Spread
    yylim = [-1 .5];
end

[~,ix_pols] = sort(fcst_plot(:,3));
F1 = figure;
xlim([1 T_smpl])
ylim(yylim)
hline = refline([0 0]);
hline.Color = 'k';
hold on
plot(fcst_plot(ix_pols,3),'color',[.2 .2 .2],'linestyle',':','linewidth',1.5)
if isempty(version_tag) % basic model
    plot(fcst_plot(ix_pols,1),'color',[1 .5 0],'linestyle','--','linewidth',1.5)
end
plot(fcst_plot(ix_pols,2),'color',[0 .5 .5],'linestyle','-','linewidth',1.5)
hold off

set(gca,'FontSize',SFont,'FontWeight','bold')
set(F1,'Units','Inches','position',[0 0 3 3]);
set(F1,'PaperOrientation','Portrait');
set(F1,'PaperPositionMode','Auto');
set(F1,'Clipping','off')
print(F1,[result_path subfolder 'T' num2str(T) '_' 'fmse_y0_all' version_tag '_sorted'],'-dpng');