%% Post Mean (QMLE, Kernel LOO, bhat)

all_param(1:2,i_est,:) = all_param(1:2,i_est_ref,:); % Initialize common parameters by QMLE
all_bhat = nan(1,n_sim);

for i_sim = 1:n_sim
    
    if mod(i_sim,100) == 0
        disp([label ', i_est = ' num2str(i_est) ', i_sim = ' num2str(i_sim)])
    end
    
    %% Pseudo out-of-sample fcst and select bw
    
    samp_ix_xy;
    X1 = XX(end,:);
    Y1 = YY(end,:);
    XX = XX(1:end-1,:);
    YY = YY(1:end-1,:);
    
    param = all_params_pseudo(:,i_sim);
    rho0 = param(1);
    sigma2_0 = param(2);
    z_rho0;
	s_z0 = std(z0);
	s_Y0 = std(Y0);
    
    lambda_aux = nan(n_bw,N);
    
    for i_bw = 1:n_bw
        bw = v_bw(i_bw)*bw0;
        q_zy_aux = normpdf(z0,z0',s_z0*bw).*normpdf(Y0,Y0',s_Y0*bw);
        q_zy = mean(q_zy_aux-diag(diag(q_zy_aux))); % take ratio, so the factor N/(N-1) will cancel out
        dq_zy = -mean(normpdf(z0,z0',s_z0*bw).*normpdf(Y0,Y0',s_Y0*bw)...
            .*(z0-z0')/(s_z0*bw)^2);

        lambda_aux(i_bw,:) = z0+dq_zy./q_zy*sigma2_0/(T-1);
    end
    
    [~,i_bw_min] = min(mean((Y1 - (lambda_aux+rho0*X1)).^2,2));
    
    all_bhat(i_sim) = v_bw(i_bw_min);
    
    %% Real fcst based on selected bw
    
    rho0 = all_param(1,i_est,i_sim);
    sigma2_0 = all_param(2,i_est,i_sim);
    
    samp_ix_xy;
    z_rho0;
	s_z0 = std(z0);
	s_Y0 = std(Y0);
    
    bw = all_bhat(i_sim)*bw0;
    
    q_zy_aux = normpdf(z0,z0',s_z0*bw).*normpdf(Y0,Y0',s_Y0*bw);
	q_zy = mean(q_zy_aux-diag(diag(q_zy_aux))); % take ratio, so the factor N/(N-1) will cancel out
	dq_zy = -mean(normpdf(z0,z0',s_z0*bw).*normpdf(Y0,Y0',s_Y0*bw)...
		.*(z0-z0')/(s_z0*bw)^2);
    
    all_lambda(i_est,ix) = z0+dq_zy./q_zy*sigma2_0/T;
    
end