#  Implement NP MLE using the REBayes package provided by Gu and Koenker (2017)

# Load package(s)
library(REBayes)
library(R.matlab)

# Set working directory
# https://stackoverflow.com/a/15373917
thisFile <- function() {
  cmdArgs <- commandArgs(trailingOnly = FALSE)
  needle <- "--file="
  match <- grep(needle, cmdArgs)
  if (length(match) > 0) {
    # Rscript
    return(normalizePath(sub(needle, "", cmdArgs[match])))
  } else {
    # 'source'd via R console
    return(normalizePath(sys.frames()[[1]]$ofile))
  }
}

setwd(paste0(dirname(dirname(thisFile())),"/temp"))
# If error occurred in setting the working directory automatically, 
# please set it manually to the "ReplicationFiles/temp" directory by setwd().

# NP MLE
data = readMat("tmp.mat")
out.gk <- GLmix(as.numeric(data$z0),sigma=as.numeric(data$sigma.gk))
write.table(out.gk$dy, file = "tmp.txt", row.names=FALSE, col.names=FALSE)