%% Post Mean (QMLE, Mixture, Khat)

all_param(1:2,i_est,:) = all_param(1:2,i_est_ref,:); % Initialize common parameters by QMLE
all_Khat = nan(n_K+2,n_sim);

for i_sim = 1:n_sim
    
    if mod(i_sim,100) == 0
        disp([label ', i_est = ' num2str(i_est) ', i_sim = ' num2str(i_sim)])
    end
    
    %% Pseudo out-of-sample fcst and select K
    
    samp_ix_xy;
    X1 = XX(end,:);
    Y1 = YY(end,:);
    XX = XX(1:end-1,:);
    YY = YY(1:end-1,:);
    
    param = all_params_pseudo(:,i_sim);
    rho0 = param(1);
    sigma2_0 = param(2);
    z_rho0;

    lambda_aux = nan(n_K,N);
    
    for i_K = 1:n_K
        K = v_K(i_K);
        [~,model] = mixGaussEm(z0,K,init_grp);
        KK = length(model.w);
        
        qz = model.w*normpdf(z0,model.mu',sqrt(squeeze(model.Sigma)));
        dqz = -model.w*(normpdf(z0,model.mu',sqrt(squeeze(model.Sigma)))...
            .*(z0-model.mu')./squeeze(model.Sigma));
    
        lambda_aux(i_K,:) = z0+dqz./qz*sigma2_0/(T-1);
        all_Khat(i_K,i_sim) = KK;
    end
    
    [~,i_K_min] = min(mean((Y1 - (lambda_aux+rho0*X1)).^2,2));
    
    all_Khat(n_K+1,i_sim) = all_Khat(i_K_min,i_sim);
    
    %% Real fcst based on selected K
    
    rho0 = all_param(1,i_est,i_sim);
    sigma2_0 = all_param(2,i_est,i_sim);
    
    samp_ix_xy;
    z_rho0;

    K = all_Khat(n_K+1,i_sim);
    [~,model] = mixGaussEm(z0,K,init_grp);
    KK = length(model.w);
    
    qz = model.w*normpdf(z0,model.mu',sqrt(squeeze(model.Sigma)));
	dqz = -model.w*(normpdf(z0,model.mu',sqrt(squeeze(model.Sigma)))...
		.*(z0-model.mu')./squeeze(model.Sigma));
    all_lambda(i_est,ix) = z0+dqz./qz*sigma2_0/T;
    all_Khat(n_K+2,i_sim) = KK;
    
end