function f = n_log_ml_CRE(param)
% f = -2 * log marginal likelihood - N*log(T)
% concentrate out (rho and mmu)

global N XX YY Y0

T = size(YY,1);
sigma2 = param(1);
ww2_lambda = param(2);

mX = mean(XX);
mY = mean(YY);

H = [ones(1,N); Y0];
MH = eye(N)-(H'/(H*H'))*H;

rho = ((XX(:)'*YY(:)-mX*mY'*T)/sigma2+mX*MH*mY'/(sigma2/T+ww2_lambda))...
    /((sum(XX(:).^2)-sum(mX.^2)*T)/sigma2+sum((mX*MH).^2)/(sigma2/T+ww2_lambda));

ZZ = YY-rho*XX;
mZ = mean(ZZ);

% accommodate cases with ww_lambda2 = 0
f = (sum(ZZ(:).^2)-sum(mZ.^2)*T)/sigma2+sum((mZ*MH).^2)/(sigma2/T+ww2_lambda)...
    +N*log(sigma2/T+ww2_lambda)+N*(T-1)*log(sigma2);
	
end