function f = n_log_ml_RE(param)
% f = -2 * log marginal likelihood - N*log(T)
% concentrate out (rho and mmu)

global N XX YY

T = size(YY,1);
sigma2 = param(1);
ww2_lambda = param(2);

mX = mean(XX);
mY = mean(YY);

rho = ((XX(:)'*YY(:)-mX*mY'*T)/sigma2+(mX-mean(mX))*(mY-mean(mY))'/(sigma2/T+ww2_lambda))...
    /((sum(XX(:).^2)-sum(mX.^2)*T)/sigma2+sum((mX-mean(mX)).^2)/(sigma2/T+ww2_lambda));

ZZ = YY-rho*XX;
mZ = mean(ZZ);

% accommodate cases with ww_lambda2 = 0
f = (sum(ZZ(:).^2)-sum(mZ.^2)*T)/sigma2+sum((mZ-mean(mZ)).^2)/(sigma2/T+ww2_lambda)...
    +N*log(sigma2/T+ww2_lambda)+N*(T-1)*log(sigma2);

end