% Estimate common parameters for pseudo-out-of-sample forecasts that help with the selection of bhat or Khat 

all_params_pseudo = nan(2,n_sim);

for i_sim = 1:n_sim
    
    if mod(i_sim,100) == 0
        disp([label ', pseudo, i_sim = ' num2str(i_sim)])
    end

    samp_ix_xy;
    XX = XX(1:end-1,:);
    YY = YY(1:end-1,:);   
    dX = XX-mean(XX);
    rho0 = (dX(:)'*dX(:))\dX(:)'*YY(:);
    z_rho0;    
    init_pseudo = [var(YY(:)-XX(:)*rho0-kron(z0',ones(T-1,1))); var(z0)];
    
    param = fmincon(@n_log_ml_RE,init_pseudo,[],[],[],[],lb,ub,[],options);
	sigma2_0 = param(1);
	ww2_lambda0 = param(2);

	mX = mean(XX);
	mY = mean(YY);

	rho0 = ((XX(:)'*YY(:)-mX*mY'*(T-1))/sigma2_0+(mX-mean(mX))*(mY-mean(mY))'/(sigma2_0/(T-1)+ww2_lambda0))...
		/((sum(XX(:).^2)-sum(mX.^2)*(T-1))/sigma2_0+sum((mX-mean(mX)).^2)/(sigma2_0/(T-1)+ww2_lambda0));
		
    all_params_pseudo(:,i_sim) = [rho0 sigma2_0];
end